{*********************************************************}
{* "MOSFET (CMOS) NAND" unit for LogicGates9 application *}
{*********************************************************}

unit nand2;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls, Grids, common;

type
  {*********}
  { TfNand2 }
  {*********}
  TfNand2 = class(TForm)
    stTitle: TStaticText;
    StaticText1: TStaticText;
    edGate, edMosfet: TMemo;
    Label1, Label2, Label3, Label4, Label5: TLabel;
    laM1, laM2, laM3, laM4: TLabel;
    laM1Status, laM2Status, laM3Status, laM4Status: TLabel;
    Image1, Image2, Image3, Image4: TImage;
    imSwitch1, imSwitch2: TImage;
    shSwitch1H, shSwitch1V, shSwitch2H, shSwitch2V: TShape;
    shLed1, shLed2, shLed3: TShape;
    Shape1, Shape10, Shape11, Shape12, Shape13, Shape14, Shape18, Shape19: TShape;
    Shape2, Shape21, Shape22, Shape23, Shape26, Shape27, Shape28, Shape29: TShape;
    Shape3, Shape30, Shape31, Shape32, Shape35, Shape36, Shape37, Shape38: TShape;
    Shape39, Shape4, Shape40, Shape41, Shape42, Shape5, Shape6, Shape7, Shape8, Shape9: TShape;
    sgTruthTable: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure imSwitch1Click(Sender: TObject);
    procedure imSwitch2Click(Sender: TObject);
  private
    rdSwitchA, rdSwitchB: TSwitch;
    rdLedA, rdLedB, rdLedOut: TLed;
    rdMosfet1, rdMosfet2, rdMosfet3, rdMosfet4: TMosfet;
  end;

var
  fNand2: TfNand2;

implementation

{$R *.lfm}

{*********}
{ TfNand2 }
{*********}

{ Application start: Initialisations }

procedure TfNand2.FormCreate(Sender: TObject);

begin
  laM1.Caption := StringReplace(laM1.Caption, '1', SUB_1, [rfReplaceAll]);
  laM2.Caption := StringReplace(laM2.Caption, '2', SUB_2, [rfReplaceAll]);
  laM3.Caption := StringReplace(laM3.Caption, '3', SUB_3, [rfReplaceAll]);
  laM4.Caption := StringReplace(laM4.Caption, '4', SUB_4, [rfReplaceAll]);
  edMosfet.Text := StringReplace(edMosfet.Text, '1', SUB_1, [rfReplaceAll]);
  edMosfet.Text := StringReplace(edMosfet.Text, '2', SUB_2, [rfReplaceAll]);
  edMosfet.Text := StringReplace(edMosfet.Text, '3', SUB_3, [rfReplaceAll]);
  edMosfet.Text := StringReplace(edMosfet.Text, '4', SUB_4, [rfReplaceAll]);
  // Switches
  with rdSwitchA do begin
    shSwitchH := shSwitch1H; shSwitchV := shSwitch1V; imSwitch := imSwitch1;
    iPosOffH := shSwitch1H.Top; iPosOffV := shSwitch1V.Top;
    bStatus := False;
  end;
  with rdSwitchB do begin
    shSwitchH := shSwitch2H; shSwitchV := shSwitch2V; imSwitch := imSwitch2;
    iPosOffH := shSwitch2H.Top; iPosOffV := shSwitch2V.Top;
  end;
  // LEDs
  rdLedA.shLed := shLed1;
  rdLedB.shLed := shLed2;
  rdLedOut.shLed := shLed3;
  // MOSFETs
  rdMosfet1.laStatus := laM1Status; rdMosfet1.cChannel := 'N';
  rdMosfet2.laStatus := laM2Status; rdMosfet2.cChannel := 'N';
  rdMosfet3.laStatus := laM3Status; rdMosfet3.cChannel := 'P';
  rdMosfet4.laStatus := laM4Status; rdMosfet4.cChannel := 'P';
end;

{ Window show-up: Start the simulation }

procedure TfNand2.FormActivate(Sender: TObject);

begin
  Init2(rdSwitchA, rdSwitchB, rdLedA, rdLedB, rdLedOut, rdMosfet1, rdMosfet2, rdMosfet3, rdMosfet4);
end;

{ Switch A or B closed/opened: Adapt the simulation }

procedure TfNand2.imSwitch1Click(Sender: TObject);

begin
  SwitchPush(rdSwitchA, rdLedA);
  GateNand2(rdSwitchA, rdSwitchB, rdMosfet1, rdMosfet2, rdMosfet3, rdMosfet4, rdLedOut);
end;

procedure TfNand2.imSwitch2Click(Sender: TObject);

begin
  SwitchPush(rdSwitchB, rdLedB);
  GateNand2(rdSwitchA, rdSwitchB, rdMosfet1, rdMosfet2, rdMosfet3, rdMosfet4, rdLedOut);
end;

end.

